Summary:        Network Presence Binding Daemon
Name:           tang
Version:        14
Release:        3%{?dist}
License:        GPL-3.0-or-later
URL:            https://github.com/latchset/%{name}
Source0:        https://github.com/latchset/%{name}/releases/download/v%{version}/%{name}-%{version}.tar.xz
Source1:        tang.sysusers

BuildRequires:  gcc meson pkgconfig jose >= 8
BuildRequires:  libjose-devel >= 8 libjose-zlib-devel >= 8 libjose-openssl-devel >= 8
BuildRequires:  systemd systemd-devel systemd-rpm-macros
BuildRequires:  curl asciidoc coreutils grep socat sed iproute
BuildRequires:  http-parser-devel >= 2.7.1-3

%{?systemd_requires}
Requires:       coreutils
Requires:       jose >= 8
Requires:       grep
Requires:       sed

Requires(pre):  shadow-utils

%description
Tang is a small daemon for binding data to the presence of a third party.



%prep
%autosetup -p1



%build
%meson
%meson_build



%install
%meson_install
install -D -pm0644 %{SOURCE1} %{buildroot}%{_sysusersdir}/tang.conf
%{__mkdir_p} %{buildroot}/%{_localstatedir}/db/%{name}



%check
%meson_test



%pre
%sysusers_create_compat %{SOURCE1}
exit 0

%post
%systemd_post %{name}d.socket

if [ -d /var/db/tang ]; then
    for k in /var/db/tang/*.jwk; do
        test -e "${k}" || continue
        chmod 0440 -- "${k}"
    done
    for k in /var/db/tang/.*.jwk; do
        test -e "${k}" || continue
        chmod 0440 -- "${k}"
    done
    chown tang:tang -R /var/db/tang
fi

%preun
%systemd_preun %{name}d.socket

%postun
%systemd_postun_with_restart %{name}d.socket


%files
%license COPYING
%{_bindir}/%{name}-show-keys
%{_libexecdir}/%{name}d-keygen
%{_libexecdir}/%{name}d-rotate-keys
%{_libexecdir}/%{name}d
%attr(0700, %{name}, %{name}) %{_localstatedir}/db/%{name}
%{_unitdir}/%{name}d@.service
%{_unitdir}/%{name}d.socket
%{_sysusersdir}/tang.conf
%{_mandir}/man8/tang.8*
%{_mandir}/man1/tang-show-keys.1*
%{_mandir}/man1/tangd-rotate-keys.1.*


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 14-3
- Rebuilt for loongarch release

* Tue Mar 19 2024 Rebuild Robot <rebot@opencloudos.org> - 14-2
- Rebuilt for jansson

* Thu Jan 04 2024 Upgrade Robot <upbot@opencloudos.org> - 14-1
- Upgrade to version 14

* Thu Nov 09 2023 rockerzhu <rockerzhu@tencent.com> - 11-5
- Fixes CVE-2023-1672.

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 11-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 11-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 11-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Dec 1 2022 cunshunxia <cunshunxia@tencent.com> - 11-1
- initial build
